# -*- coding: utf-8 -*-
import time


class Stopwatch(object):
	
	####################################################
	def __init__(self):
		self.m1stTime = 0.0
		self.mNowTime = 0.0
		self.mElapsedTime = 0.0
		self.mElapsedTime0 = 0.0
		self.mElapsedTime1 = 0.0
		self.mIsRunning = False

	####################################################
	def updateNowTime(self):
		self.mNowTime = time.time()
		return self.mNowTime
	
	####################################################
	def clear(self):
		status = self.mIsRunning
		self.reset()
		self.mIsRunning = status

		if status == True:
			self.m1stTime = self.updateNowTime()

		return status
	
	####################################################
	def reset(self):
		self.m1stTime = 0.0
		self.mNowTime = 0.0
		self.mElapsedTime = 0.0
		self.mElapsedTime0 = 0.0
		self.mElapsedTime1 = 0.0
		self.mIsRunning = False

	####################################################
	def start(self):
		reuslt = False

		if self.mIsRunning == False:
			self.reset()
			self.updateNowTime()
			self.m1stTime = self.mNowTime
			self.mIsRunning = True
			result = True

		return result

	####################################################
	def restart(self):
		reuslt = False

		if self.mIsRunning == False:
			self.mElapsedTime0 += self.mElapsedTime1
			self.mElapsedTime1 = 0.0
			self.updateNowTime()
			self.m1stTime = self.mNowTime
			self.mIsRunning = True
			result = True

		return result

	####################################################
	def stop(self):
		result = False

		if self.mIsRunning == True:
			self.updateNowTime()
			self.calcElapsedTime()
			self.mIsRunning = False
			result = True

		return result
	
	####################################################
	def getElapsedSecond(self):
		return self.calcElapsedTime()

	####################################################
	def calcElapsedTime(self):
		if self.mIsRunning == True:
			self.updateNowTime()
			self.mElapsedTime1 = self.mNowTime - self.m1stTime
		self.mElapsedTime = self.mElapsedTime0 + self.mElapsedTime1

		return self.mElapsedTime

